/*
 * Copyright (c) 2003 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

//---------------------------------------------------------------------------
//
//      DLLvOCۃNX
//
//---------------------------------------------------------------------------
#ifndef dll_plugin_h
#define dll_plugin_h

#include <windows.h>

//---------------------------------------------------------------------------
class Dll_plugin
{
protected :
    HMODULE m_handle;

    //I[o[[hDLL̊֐擾
    virtual void adress_set(void) = 0;

public :
    Dll_plugin()
    {
        m_handle = NULL;
    };

    virtual ~Dll_plugin()
    {
        if (m_handle != NULL) FreeLibrary(m_handle);
    };

    void dll_load(const char *dllpath)
    {
        if (m_handle != NULL)
		{
            FreeLibrary(m_handle);
            //m_handle = NULL;
        }

        m_handle = LoadLibrary(dllpath);

        if (m_handle != NULL) adress_set();
    };
};

#endif /* dll_plugin.h */
