/*
 * Copyright (c) 2003 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <windows.h>
#include "spi00in.h"
#include "j2kspi.h"

//`ƓVnt]Ȃ
//#define TENTIMUYOU

//TCY
#define SKIPSIZE 0x3f

//O[oϐ
J2kspi g_j2k;

/*-------------------------------------------------------------------------*/
/*  Plugin ̏ */
/*-------------------------------------------------------------------------*/
static const char *pluginfo[] = {
	"00IN",
	"QCF^H^H^HS~tJPEG2000 to DIB",
	"*.*",
	"S~tJ2000 file",
};

/*
 * SPI֐
 */

int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
	if (infono < 0 || infono >= (sizeof(pluginfo) / sizeof(char *))) 
		return 0;

	lstrcpyn(buf, pluginfo[infono], buflen);

	return lstrlen(buf);
}

int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
	if (g_j2k.IsSupported == NULL) return 0;

//j2k.spi̓͂ȂƂ߂
	char *data;
	char buff[2000+SKIPSIZE];

	if ((dw & 0xFFFF0000) == 0) {
	/* dw̓t@Cnh */
		DWORD ReadBytes;
		if (!ReadFile((HANDLE)dw, buff, 2000+SKIPSIZE, &ReadBytes, NULL)) {
			return 0;
		}
		data = buff +SKIPSIZE;
	} else {
	/* dw̓obt@ւ̃|C^ */
		data = (char *)dw +SKIPSIZE;
	}

	return g_j2k.IsSupported(filename, (DWORD)data);
}

int __stdcall GetPictureInfo
(LPSTR buf, long len, unsigned int flag, struct PictureInfo *lpInfo)
{
	if (g_j2k.GetPictureInfo == NULL) return SPI_NOT_SUPPORT;

	if ((flag & 7) == 0) {
	/* buf̓t@C */
		return g_j2k.GetPictureInfo(buf, len +SKIPSIZE, flag, lpInfo);
	}

	/* buf̓t@CC[Wւ̃|C^ */
	return g_j2k.GetPictureInfo(buf +SKIPSIZE, len -SKIPSIZE, flag, lpInfo);
}

int __stdcall GetPicture(
		LPSTR buf, long len, unsigned int flag, 
		HANDLE *pHBInfo, HANDLE *pHBm,
		SPI_PROGRESS lpPrgressCallback, long lData)
{
	if (g_j2k.GetPicture == NULL) return SPI_NOT_SUPPORT;

//j2k.spi̓͂ȂƂ߂
	char *data;
	long datasize;

	if ((flag & 7) == 0) {
	/* buf̓t@C */
		HANDLE hf;
		DWORD ReadBytes;
		hf = CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hf == INVALID_HANDLE_VALUE) return SPI_FILE_READ_ERROR;
		datasize = GetFileSize(hf, NULL) -len -SKIPSIZE;
		if (SetFilePointer(hf, len +SKIPSIZE, NULL, FILE_BEGIN) != (DWORD)(len +SKIPSIZE)) {
			CloseHandle(hf);
			return SPI_FILE_READ_ERROR;
		}
		data = (char *)LocalAlloc(LMEM_FIXED, datasize);
		if (data == NULL) {
			CloseHandle(hf);
			return SPI_NO_MEMORY;
		}
		if (!ReadFile(hf, data, datasize, &ReadBytes, NULL)) {
			CloseHandle(hf);
			LocalFree(data);
			return SPI_FILE_READ_ERROR;
		}
		CloseHandle(hf);
		if (ReadBytes != (DWORD)datasize) {
			LocalFree(data);
			return SPI_FILE_READ_ERROR;
		}
	} else {
	/* buf̓t@CC[Wւ̃|C^ */
		data = buf +SKIPSIZE;
		datasize = len -SKIPSIZE;
	}

#ifdef TENTIMUYOU
	return g_j2k.GetPicture(data, datasize, 1, pHBInfo, pHBm, lpPrgressCallback, lData);
#else
	HANDLE himg;
	DWORD ret = g_j2k.GetPicture(data, datasize, 1, pHBInfo, &himg, lpPrgressCallback, lData);
	if (ret == SPI_ALL_RIGHT) {
		*pHBm = LocalAlloc(LMEM_FIXED, LocalSize(himg));
		if (*pHBm == NULL) {
			LocalFree(*pHBInfo);
			LocalFree(himg);
			return SPI_NO_MEMORY;
		}
		BITMAPINFO *pbmi = (BITMAPINFO *)*pHBInfo;
		DWORD linesize = (pbmi->bmiHeader.biWidth * pbmi->bmiHeader.biBitCount/8 +3) & ~3;
		DWORD imgsize = linesize * pbmi->bmiHeader.biHeight;
		char *psrc = (char*)himg +imgsize;
		char *pdes = (char*)*pHBm;
		//8,16,24,32bitz
		for (int y=0; y<pbmi->bmiHeader.biHeight; y++) {
			psrc -= linesize;
			memcpy(pdes, psrc, linesize);
			pdes += linesize;
		}
		LocalFree(himg);
	}
	return ret;
#endif
}

int __stdcall GetPreview(
	LPSTR buf, long len, unsigned int flag,
	HANDLE *pHBInfo, HANDLE *pHBm,
	SPI_PROGRESS lpPrgressCallback, long lData)
{
	return SPI_NO_FUNCTION;
}
